/* EDIT.CMD */ ProgVer = 'EDIT v2002.12.01'
/*
   Useage: From an OS/2 command prompt type "EDIT filename"
   Verwendung: Auf der Kommandozeile "EDIT Dateiname" tippen

   Status: Released into the public domain.

   Contributors Date      Versions
   ------------ --------- --------------
   C. Morrison  15 Jul 94 First release
   K. Kulbarsch 12 Oct 02 Erste deutsche Version
   N. Morrow    01 Dec 02 Second release

   Contact Information
   -------------------
   N. Morrow - morrownr@netscape.net

   Notes:

   - I currently have the following To-Do list I'm working on but my time
     is limited currently so I thought I'd give a chance for others in
     the community to help:

     -- Add Save As capability

     -- Add Rename capability (F7)

     -- Add error checking to ensure invalid filenames are rejected

     -- Add Find, Find Again and Replace capability (Ctrl-F/Ctrl-G/Ctrl-?)

     -- Optimize code

     -- Add Cut, Copy and Paste capability

     -- Beef up error handling

   - As this code is released to the Public Domain, you are free to do
     with it as you please, however, I do ask that if you modify and
     make a new release that you do not use the name EDIT.CMD as I 
     would prefer to continue to use that name for the releases I make.

   - I would like to hear from those that decide to work on the code.  If
     you find a better to do something please send it to me and I'll try
     to include it in my release.

   Known issues:

   - Loading large files when Object Rexx is active is very slow.  If
     anyone knows a way to test to see which version of Rexx is active
     I'd appreciate you emailing me.  Also, if anyone with Object Rexx
     programming experience knows a better way to write the LoadTextFile:
     subroutine I'd like to hear from you.

   - EDIT is currently set to detect when it is running on a system using
     the German language.  The German translation can be found by searching
     for "GERMAN:".  This section is not complete, however, I do not speak
     German and could use some help.  Anyone else wanting to translate into
     another language should find all that is needed near the end of this
     file.

   DISCLAIMER:

   THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS "AS IS" AND ANY EXPRESS
   OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   DISCLAIMED. IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
   INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
   SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
   STRICT LIABILITY, OR TORT(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
   ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE.

   End users should feel free to modify the following section:
   Edit is designed to have an editing area that is easily resized.
   The following Standard Editing Area statements are set to 0,0,19,79 as
   these are the the maximum sizes that work in a 80x25 full screen mode.
*/
                          /* 'mode 120,30'           */      
ScreenTopRow      =  0    /* ScreenTopRow      =   0 */
ScreenLeftColumn  =  0    /* ScreenLeftColumn  =   0 */
ScreenBottomRow   = 19    /* ScreenBottomRow   =  24 */
ScreenRightColumn = 79    /* ScreenRightColumn = 119 */
TabSize           =  4    /* TabSize           =   8 */

/* Calculate Screen Size */
ScreenHeight = ScreenBottomRow   - ScreenTopRow     + 1
ScreenWidth  = ScreenRightColumn - ScreenLeftColumn + 1

/* Load Required DLL */
IF RxFuncQuery('SysLoadFuncs') THEN
  DO
    CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
    CALL SysLoadFuncs
  END

/* Detects and Loads Language */
Lang = SUBSTR(VALUE('LANG',,'OS2ENVIRONMENT'),1,2)
SELECT
  WHEN Lang = 'DE' | Lang = 'de' THEN CALL Deutsche
  /* WHEN Lang = 'NL' THEN CALL Dutch */
  /* WHEN Lang = 'ES' THEN CALL Espaol */
  /* WHEN Lang = 'IT' THEN CALL Italian */
  /* WHEN Lang = 'FR' THEN CALL French */
  /* WHEN Lang = 'PT' THEN CALL Portuguese */
  /* WHEN Lang = 'RU' THEN CALL Russian */
  OTHERWISE CALL English
END

/* Initialize Variables *********************** Used by: ******/
CursorRowInDocument       = 1                /* DisplayStats: */
CursorColumnInDocument    = 1                /* DisplayStats: */
CursorColumnInDocumentMem = 1
DocumentTopRow            = 1                /* DrawScreen:   */
DocumentLeftColumn        = 1                /* DrawScreen:   */
CursorRowOnScreen         = ScreenTopRow
CursorColumnOnScreen      = ScreenLeftColumn
Modified                  = 0
InsMode                   = 1
LoadTime                  = '-'

/* Main */
PARSE ARG textfile .
CALL LoadTextFile
CALL LoadKeys
CALL DrawScreen
CALL DrawMenu
CALL DisplayStats
DO FOREVER
  CALL SysCurPos CursorRowOnScreen, CursorColumnOnScreen
  CALL SysCurState 'ON'
  inkey = SysGetKey('NOECHO')
  CALL SysCurState 'OFF'
/* Debug */ CALL SysCurPos ScreenBottomRow + 1, ScreenLeftColumn
/* Debug */ SAY ''
  SELECT
    WHEN inkey = Enter_Key             THEN CALL DoEnter
    WHEN inkey = Backspace_Key         THEN CALL DoBackSpace
    WHEN inkey = Tab_Key               THEN CALL DoTab
    WHEN inkey = Esc_Key               THEN CALL DoQuit
    WHEN inkey = Ctrl_F                THEN CALL DoFind
    WHEN inkey = Ctrl_G                THEN CALL DofindaGain
    WHEN inkey = '00'x | inkey = 'E0'x THEN 
      DO
        inkey2 = SysGetKey('NOECHO')
        SELECT
          WHEN inkey2 = Insert_Key     THEN CALL DoInsert
          WHEN inkey2 = Ctrl_Insert    THEN CALL DoCtrlInsert
          WHEN inkey2 = Delete_Key     THEN CALL DoDelete
          WHEN inkey2 = Ctrl_Delete    THEN CALL DoCtrlDelete
          WHEN inkey2 = Home_Key       THEN CALL DoHome
          WHEN inkey2 = Ctrl_Home      THEN CALL DoCtrlHome
          WHEN inkey2 = End_Key        THEN CALL DoEnd
          WHEN inkey2 = Ctrl_End       THEN CALL DoCtrlEnd
          WHEN inkey2 = PgUp_Key       THEN CALL DoPgUp
          WHEN inkey2 = PgDn_Key       THEN CALL DoPgDn
          WHEN inkey2 = DnArrow_Key    THEN CALL DoDnArrow
          WHEN inkey2 = UpArrow_Key    THEN CALL DoUpArrow
          WHEN inkey2 = RightArrow_Key THEN CALL DoRightArrow
          WHEN inkey2 = LeftArrow_Key  THEN CALL DoLeftArrow
          WHEN inkey2 = F1             THEN CALL DoHelp
          WHEN inkey2 = F2             THEN CALL DoSave
          WHEN inkey2 = F3             THEN CALL DoQuit
          WHEN inkey2 = F7             THEN CALL DoRename
          WHEN inkey2 = F12            THEN CALL DoInfo
          OTHERWISE NOP
        END
      END
    OTHERWISE
      IF C2D(inkey) > 31 THEN CALL WriteChar
  END
END

/* Core Subroutines */

DoEnter:
linePart1 = SUBSTR(line.CursorRowInDocument, 1, CursorColumnInDocument -1)
linePart2 = SUBSTR(line.CursorRowInDocument, CursorColumnInDocument)
line.0    = line.0 + 1
DO x      = line.0 TO (CursorRowInDocument + 2) BY -1
  y       = x - 1
  line.x  = line.y
END
line.CursorRowInDocument  = linePart1
lineBelow                 = 1 + CursorRowInDocument
line.lineBelow            = linePart2
CursorRowInDocument       = 1 + CursorRowInDocument
CursorColumnInDocument    = 1
CursorColumnInDocumentMem = CursorColumnInDocument
DocumentLeftColumn        = 1
IF CursorRowOnScreen      < ScreenBottomRow THEN
  DO
    CursorRowOnScreen     = 1 + CursorRowOnScreen
  END
ELSE
  DO
    DocumentTopRow        = 1 + DocumentTopRow
  END
CursorColumnOnScreen      = ScreenLeftColumn
Modified = 1; Call DrawScreen; CALL DisplayStats; RETURN


DoBackSpace:
IF CursorColumnInDocument     > 1 THEN
  DO /* if wrapping to the line above not required */
    CursorColumnInDocument    = CursorColumnInDocument - 1
    CursorColumnInDocumentMem = CursorColumnInDocument
    line.CursorRowInDocument  = DELSTR(line.CursorRowInDocument,,
                                      CursorColumnInDocument, 1)
    IF CursorColumnOnScreen   > ScreenLeftColumn THEN
      DO /* moves cursor, leave document in place */
        CursorColumnOnScreen  = CursorColumnOnScreen - 1
        iline = SUBSTR(line.CursorRowInDocument, DocumentLeftColumn,,
                       ScreenWidth, ' ')
        CALL SysCurPos CursorRowOnScreen, ScreenLeftColumn
        SAY iline
      END
    ELSE
      DO
        IF DocumentLeftColumn > 1 THEN
          DO /* moves document, leaves cursor in place */
            DocumentLeftColumn = DocumentLeftColumn - 1
            CALL DrawScreen
          END
        ELSE
          DO
            CursorColumnOnScreen  = CursorColumnOnScreen - 1
            iline = SUBSTR(line.CursorRowInDocument, DocumentLeftColumn,,
                           ScreenWidth, ' ')
            CALL SysCurPos CursorRowOnScreen, ScreenLeftColumn
            SAY iline
          END            
      END
    Modified = 1
  END
ELSE
  DO
    IF CursorRowInDocument           > 1 THEN
      DO /* if wrapping cursor to end of line above */
        linePart2                    = line.CursorRowInDocument
        CursorRowInDocument          = CursorRowInDocument - 1
        linePart1                    = line.CursorRowInDocument
        LineLength                   = LENGTH(line.CursorRowInDocument)
        line.CursorRowInDocument     = INSERT(linePart1, linePart2)
        lastLine                     = line.0        
        line.0                       = line.0 - 1
        DO x = (CursorRowInDocument + 1) TO line.0
          y  = x + 1
          line.x = line.y
        END
        line.lastLine                = ''
        CursorColumnInDocument       = 1 + LineLength
        CursorColumnInDocumentMem    = CursorColumnInDocument
        CursorColumnOnScreen         = ScreenLeftColumn + LineLength
        IF CursorRowOnScreen         > ScreenTopRow THEN
          DO /* if cursor is not on the top row */
            CursorRowOnScreen        = CursorRowOnScreen - 1
            IF CursorColumnOnScreen  > ScreenRightColumn THEN
              DO
                CursorColumnOnScreen = ScreenRightColumn
                DocumentLeftColumn   = 1 + CursorColumnInDocument,
                                       - ScreenWidth
              END
            Modified = 1
            CALL DrawScreen
          END
        ELSE
          DO
            DocumentTopRow           = DocumentTopRow - 1
            IF CursorColumnOnScreen  > ScreenRightColumn THEN
              DO
                CursorColumnOnScreen = ScreenRightColumn
                DocumentLeftColumn   = 1 + CursorColumnInDocument,
                                       - ScreenWidth
               END
            Modified = 1
            CALL DrawScreen
          END
      END
    ELSE
      DO /* if cursor at beginning of document */
        CALL DoErrorBeep
      END
  END
CALL DisplayStats; RETURN


DoTab:
x                         = 0
nextTab                   = 0
DO UNTIL nextTab          > CursorColumnInDocument
  x                       = x + 1
  nextTab                 = TabSize * x
END
neededspaces              = nextTab - CursorColumnInDocument
line.CursorRowInDocument  = INSERT('',,
                                   line.CursorRowInDocument,,
                                   CursorColumnInDocument - 1,,
                                   neededspaces)
CursorColumnInDocument    = CursorColumnInDocument + neededspaces
CursorColumnInDocumentMem = CursorColumnInDocument
IF CursorColumnOnScreen   + neededspaces < ScreenRightColumn + 1 THEN
  DO
    iline                 = SUBSTR(line.CursorRowInDocument,,
                                   DocumentLeftColumn,,
                                   ScreenWidth,,
                                   ' ')
    CALL SysCurPos CursorRowOnScreen, ScreenLeftColumn
    SAY iline
    CursorColumnOnScreen  = CursorColumnOnScreen + neededspaces
  END
ELSE
  DO
    DocumentLeftColumn    = DocumentLeftColumn + neededspaces
    CALL Drawscreen
  END
Modified = 1; CALL DisplayStats; RETURN


DoFind:
/* WORDPOS */
RETURN


DoFindaGain:
RETURN


DoInsert:
IF InsMode = 1 THEN
  DO
    InsMode = 0
  END
ELSE
  DO
    InsMode = 1
  END
CALL DisplayStats; RETURN


DoCtrlInsert:
line.0   = line.0 + 1
DO x     = line.0 TO (CursorRowInDocument + 1) BY -1
  y      = x - 1
  line.x = line.y
END
line.CursorRowInDocument  = ''
CursorColumnInDocument    = 1
CursorColumnInDocumentMem = CursorColumnInDocument
DocumentLeftColumn        = 1
CursorColumnOnScreen      = ScreenLeftColumn
Modified = 1; Call DrawScreen; CALL DisplayStats; RETURN


DoDelete:
LineLength = LENGTH(line.CursorRowInDocument)
IF CursorColumnInDocument < 1 + LineLength THEN
  DO
    line.CursorRowInDocument = DELSTR(line.CursorRowInDocument,,
                                      CursorColumnInDocument, 1)
    iline = SUBSTR(line.CursorRowInDocument, DocumentLeftColumn,,
                   ScreenWidth, ' ')
    CALL SysCurPos CursorRowOnScreen, ScreenLeftColumn
    SAY iline
    Modified = 1
  END
ELSE
  DO
    lineBelow = 1 + CursorRowInDocument
    IF lineBelow < 1 + line.0 THEN
      DO
        line.CursorRowInDocument = INSERT(line.CursorRowInDocument,,
                                          line.lineBelow)
        DO x = lineBelow TO line.0
          y = 1 + x
          line.x = line.y
        END
        lastLine = line.0
        line.lastLine = ''
        line.0 = line.0 - 1
        CALL DrawScreen
        Modified = 1
      END
    ELSE
      DO
        CALL DoErrorBeep
      END
  END
CALL DisplayStats; RETURN


DoCtrlDelete:
IF 1 + CursorRowInDocument > line.0 THEN
  DO
    line.CursorRowInDocument = ''
  END
ELSE
  DO
    DO x = CursorRowInDocument TO line.0 - 1
      y = 1 + x
      line.x = line.y
    END
    lastLine = line.0
    line.lastLine = ''
    line.0 = line.0 - 1
  END
Modified = 1; CALL DrawScreen; CALL DisplayStats; RETURN


DoHome:
IF CursorColumnInDocument     > 1 THEN
  DO /* if the cursor is not at the beginning of the line */
    CursorColumnInDocument    = 1
    CursorColumnInDocumentMem = CursorColumnInDocument
    CursorColumnOnScreen      = ScreenLeftColumn
    IF DocumentLeftColumn     > 1 THEN
      DO /* if the left column of the line is not left justified */
        DocumentLeftColumn    = 1
        CALL DrawScreen
      END
    CALL DisplayStats
   END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoCtrlHome:
IF DocumentTopRow             > 1 THEN
  DO
    CursorRowInDocument       = 1
    CursorColumnInDocument    = 1
    CursorColumnInDocumentMem = 1
    DocumentTopRow            = 1
    DocumentLeftColumn        = 1
    CursorRowOnScreen         = ScreenTopRow
    CursorColumnOnScreen      = ScreenLeftColumn
    CALL DrawScreen
    CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoEnd:
LineLength                    = LENGTH(line.CursorRowInDocument)
IF CursorColumnInDocument     < 1 + LineLength THEN
  DO /* if cursor is not at the end of the line */
    CursorColumnInDocument    = 1 + LineLength
    CursorColumnInDocumentMem = CursorColumnInDocument
    CursorColumnOnScreen      = ScreenLeftColumn + LineLength
    IF CursorColumnOnScreen   > ScreenRightColumn THEN
      DO /* if the right column of the line is not right justified */
        CursorColumnOnScreen  = ScreenRightColumn
        DocumentLeftColumn    = 1 + CursorColumnInDocument - ScreenWidth
        CALL DrawScreen
      END
    CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoCtrlEnd:
IF DocumentTopRow             < line.0 - ScreenHeight + 1 THEN
  DO
    CursorRowInDocument       = line.0
    CursorColumnInDocument    = 1
    CursorColumnInDocumentMem = 1
    DocumentTopRow            = line.0 - ScreenHeight + 1
    DocumentLeftColumn        = 1
    CursorRowOnScreen         = ScreenTopRow + ScreenHeight - 1
    CursorColumnOnScreen      = ScreenLeftColumn 
    CALL DrawScreen
    CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoPgUp:
IF DocumentTopRow              > 1 THEN
  DO
    IF DocumentTopRow          > ScreenHeight - 1 THEN
      DO
        DocumentTopRow         = DocumentTopRow      - ScreenHeight
        CursorRowInDocument    = CursorRowInDocument - ScreenHeight
      END
    ELSE
      DO
        X                      = DocumentTopRow
        DocumentTopRow         = 1
        Y                      = X - DocumentTopRow 
        CursorRowInDocument    = CursorRowInDocument - Y
      END
    CursorColumnInDocument     = CursorColumnInDocumentMem
    LineLength                 = LENGTH(line.CursorRowInDocument)
    IF CursorColumnInDocument  > 1 + LineLength THEN
      DO
        CursorColumnInDocument = 1 + LineLength
      END
    CursorColumnOnScreen       = CursorColumnInDocument,
                                 + ScreenLeftColumn,
                                 - DocumentLeftColumn
    IF CursorColumnOnScreen    < ScreenLeftColumn THEN
      DO
        DocumentLeftColumn     = 1 + LineLength
      END
    IF CursorColumnOnScreen    > ScreenRightColumn THEN
      DO /* if document needs to be moved to the left */
        DocumentLeftColumn     = CursorColumnInDocument,
                                 - ScreenWidth + 1
      END
    CursorColumnOnScreen       = CursorColumnInDocument,
                                 + ScreenLeftColumn,
                                 - DocumentLeftColumn
    CALL DrawScreen; CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoPgDn:
IF line.0                      > DocumentTopRow + ScreenHeight - 1 THEN
  DO /* if lines of text currently exceeds the screen bottom row */
    IF line.0 - ScreenHeight   > DocumentTopRow + ScreenHeight THEN         
      DO
        DocumentTopRow         = DocumentTopRow      + ScreenHeight
        CursorRowInDocument    = CursorRowInDocument + ScreenHeight
      END
    ELSE
      DO
        X                      = DocumentTopRow
        DocumentTopRow         = line.0 - ScreenHeight + 1
        Y                      = DocumentTopRow        - X
        CursorRowInDocument    = CursorRowInDocument   + Y
      END
    CursorColumnInDocument     = CursorColumnInDocumentMem
    LineLength                 = LENGTH(line.CursorRowInDocument)
    IF CursorColumnInDocument  > 1 + LineLength THEN
      DO
        CursorColumnInDocument = 1 + LineLength
      END
    CursorColumnOnScreen       = CursorColumnInDocument,
                                 + ScreenLeftColumn,
                                 - DocumentLeftColumn
    IF CursorColumnOnScreen    < ScreenLeftColumn THEN
      DO
        DocumentLeftColumn     = 1 + LineLength
      END
    IF CursorColumnOnScreen    > ScreenRightColumn THEN
      DO /* if document needs to be moved to the left */
        DocumentLeftColumn     = CursorColumnInDocument,
                                 - ScreenWidth + 1
      END
    CursorColumnOnScreen       = CursorColumnInDocument,
                                 + ScreenLeftColumn,
                                 - DocumentLeftColumn
    CALL DrawScreen; CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoDnArrow:
IF CursorRowInDocument             < line.0 THEN
  DO /* if cursor is not on bottom line of document */
    CursorRowInDocument            = 1 + CursorRowInDocument
    IF CursorRowOnScreen           < ScreenBottomRow THEN
      DO /* if cursor is not on bottom line of screen */
        CursorRowOnScreen          = 1 + CursorRowOnScreen
        CursorColumnInDocument     = CursorColumnInDocumentMem
        LineLength                 = LENGTH(line.CursorRowInDocument)
        IF CursorColumnInDocument  > 1 + LineLength THEN
          DO /* if cursor needs to be moved to end of line */
            CursorColumnInDocument = 1 + LineLength
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,    
                                     - DocumentLeftColumn
        IF CursorColumnOnScreen    < ScreenLeftColumn THEN
          DO /* if document needs to be moved to the right */
            DocumentLeftColumn     = 1 + LineLength
            CALL DrawScreen
          END
        IF CursorColumnOnScreen    > ScreenRightColumn THEN
          DO /* if document needs to be moved to the left */
            DocumentLeftColumn     = CursorColumnInDocument,
                                     - ScreenWidth + 1
            CALL DrawScreen
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,
                                     - DocumentLeftColumn
      END
    ELSE
      DO /* if cursor is on the bottom line of the screen */
        DocumentTopRow             = 1 + DocumentTopRow
        CursorColumnInDocument     = CursorColumnInDocumentMem
        LineLength                 = LENGTH(line.CursorRowInDocument)
        IF CursorColumnInDocument  > 1 + LineLength THEN
          DO /* if cursor needs to be moved to end of line */
            CursorColumnInDocument = 1 + LineLength
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,    
                                     - DocumentLeftColumn
        IF CursorColumnOnScreen    < ScreenLeftColumn THEN
          DO /* if document needs to be moved to the right */
            DocumentLeftColumn     = 1 + LineLength
          END
        IF CursorColumnOnScreen    > ScreenRightColumn THEN
          DO /* if document needs to be moved to the left */
            DocumentLeftColumn     = CursorColumnInDocument,
                                     - ScreenWidth + 1
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,
                                     - DocumentLeftColumn
        CALL DrawScreen
      END
    CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoUpArrow:
IF CursorRowInDocument             > 1 THEN
  DO /* if cursor is not on top line of document */
    CursorRowInDocument            = CursorRowInDocument - 1
    IF CursorRowOnScreen           > ScreenTopRow THEN
      DO /* if cursor is not on the top line of screen */
        CursorRowOnScreen          = CursorRowOnScreen - 1
        CursorColumnInDocument     = CursorColumnInDocumentMem
        LineLength                 = LENGTH(line.CursorRowInDocument)
        IF CursorColumnInDocument  > 1 + LineLength THEN
          DO /* if cursor needs to be moved to end of line */
            CursorColumnInDocument = 1 + LineLength
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,    
                                     - DocumentLeftColumn
        IF CursorColumnOnScreen    < ScreenLeftColumn THEN
          DO /* if document needs to be moved to the right */
            DocumentLeftColumn     = 1 + LineLength
            CALL DrawScreen
          END
        IF CursorColumnOnScreen    > ScreenRightColumn THEN
          DO /* if document needs to be moved to the left */
            DocumentLeftColumn     = CursorColumnInDocument,
                                     - ScreenWidth + 1
            CALL DrawScreen
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,
                                     - DocumentLeftColumn
      END
    ELSE
      DO /* if cursor is on the top line of the screen */
        DocumentTopRow             = DocumentTopRow - 1
        CursorColumnInDocument     = CursorColumnInDocumentMem
        LineLength                 = LENGTH(line.CursorRowInDocument)
        IF CursorColumnInDocument  > 1 + LineLength THEN
          DO /* if cursor needs to be moved to end of line */
            CursorColumnInDocument = 1 + LineLength
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,    
                                     - DocumentLeftColumn
        IF CursorColumnOnScreen    < ScreenLeftColumn THEN
          DO /* if document needs to be moved to the right */
            DocumentLeftColumn     = 1 + LineLength
          END
        IF CursorColumnOnScreen    > ScreenRightColumn THEN
          DO /* if document needs to be moved to the left */
            DocumentLeftColumn     = CursorColumnInDocument,
                                     - ScreenWidth + 1
          END
        CursorColumnOnScreen       = CursorColumnInDocument,
                                     + ScreenLeftColumn,
                                     - DocumentLeftColumn
        CALL DrawScreen
      END
    CALL DisplayStats
  END
ELSE
  DO
    CALL DoErrorBeep
  END
RETURN


DoRightArrow:
LineLength                         = LENGTH(line.CursorRowInDocument)
IF CursorColumnInDocument          < 1 + LineLength THEN
  DO /* if wrapping to next line not required */
    CursorColumnInDocument         = 1 + CursorColumnInDocument
    CursorColumnInDocumentMem      = CursorColumnInDocument
    IF CursorColumnOnScreen        < ScreenRightColumn THEN
      DO /* if cursor needs to be moved (leave document in place) */
        CursorColumnOnScreen       = 1 + CursorColumnOnScreen
      END
    ELSE
      DO /* if document needs to be moved (leaves cursor in place) */
        DocumentLeftColumn         = 1 + DocumentLeftColumn
        CALL DrawScreen
      END
  END
ELSE
  DO
    IF CursorRowInDocument         < line.0 THEN
      DO /* if cursor is not on bottom line of document */
        CursorRowInDocument        = 1 + CursorRowInDocument
        CursorColumnInDocument     = 1
        CursorColumnInDocumentMem  = CursorColumnInDocument
        CursorColumnOnScreen       = ScreenLeftColumn
        IF CursorRowOnScreen       < ScreenBottomRow THEN
          DO /* if cursor is on bottom row of screen */
            IF DocumentLeftColumn  = 1 THEN
              DO /* if document is left justified */
                CursorRowOnScreen  = 1 + CursorRowOnScreen
              END
            ELSE
              DO
                DocumentLeftColumn = 1
                CursorRowOnScreen  = 1 + CursorRowOnScreen
                CALL DrawScreen
              END
          END
        ELSE
          DO
            DocumentLeftColumn     = 1
            DocumentTopRow         = 1 + DocumentTopRow
            CALL DrawScreen
          END
      END
    ELSE
      DO
        CALL DoErrorBeep
      END
  END
CALL DisplayStats
RETURN


DoLeftArrow:
IF CursorColumnInDocument            > 1 THEN
  DO /* if wrapping to next line not required */
    CursorColumnInDocument           = CursorColumnInDocument - 1
    CursorColumnInDocumentMem        = CursorColumnInDocument    
    IF CursorColumnOnScreen          > ScreenLeftColumn THEN
      DO /* Moves cursor, leave document in place */
        CursorColumnOnScreen         = CursorColumnOnScreen - 1
      END
    ELSE
      DO
        DocumentLeftColumn           = DocumentLeftColumn - 1
        CALL DrawScreen
      END
  END
ELSE
  DO
    IF CursorRowInDocument           > 1 THEN
      DO /* if wrapping cursor to end of line above */
        CursorRowInDocument          = CursorRowInDocument - 1
        LineLength                   = LENGTH(line.CursorRowInDocument)
        CursorColumnInDocument       = 1 + LineLength
        CursorColumnInDocumentMem    = CursorColumnInDocument
        CursorColumnOnScreen         = ScreenLeftColumn + LineLength
        IF CursorRowOnScreen         > ScreenTopRow THEN
          DO /* if cursor is not on the top row */
            CursorRowOnScreen        = CursorRowOnScreen - 1
            IF CursorColumnOnScreen  > ScreenRightColumn THEN
              DO
                CursorColumnOnScreen = ScreenRightColumn
                DocumentLeftColumn   = 1 + CursorColumnInDocument,
                                       - ScreenWidth
                CALL DrawScreen
              END
          END
        ELSE
          DO
            DocumentTopRow           = DocumentTopRow - 1
            IF CursorColumnOnScreen  > ScreenRightColumn THEN
              DO
                CursorColumnOnScreen = ScreenRightColumn
                DocumentLeftColumn   = 1 + CursorColumnInDocument,
                                       - ScreenWidth
               END
            CALL DrawScreen
          END
      END
    ELSE
      DO /* if cursor at beginning of document */
        CALL DoErrorBeep
      END
  END
CALL DisplayStats
RETURN


DoFind:
RETURN


DoFindaGain:
RETURN


DoHelp:
CALL SysCls
CALL SysCurPos  0,0; SAY TxHelp01
CALL SysCurPos  2,2; SAY TxHelp02
CALL SysCurPos  3,2; SAY TxHelp03
CALL SysCurPos  4,2; SAY TxHelp04
CALL SysCurPos  5,2; SAY TxHelp05              
CALL SysCurPos  6,2; SAY TxHelp06
CALL SysCurPos  7,2; SAY TxHelp07
CALL SysCurPos  8,2; SAY TxHelp08
CALL SysCurPos  9,2; SAY TxHelp09
CALL SysCurPos 10,2; SAY TxHelp10
CALL SysCurPos 11,2; SAY TxHelp11
CALL SysCurPos 12,2; SAY TxHelp12
CALL SysCurPos 13,2; SAY TxHelp13
CALL SysCurPos 14,2; SAY TxHelp14
CALL SysCurPos 15,2; SAY TxHelp15
CALL SysCurPos 16,2; SAY TxHelp16
CALL SysCurPos 17,2; SAY TxHelp17
CALL SysCurPos 18,2; SAY TxHelp18
CALL SysCurPos 19,2; SAY TxHelp19
CALL SysCurPos 20,2; SAY TxHelp20
CALL SysCurPos 23,0; SAY TxMisc02
inkey = SysGetKey('NOECHO')
IF inkey = '00'x | inkey = 'E0'x THEN inkey2 = SysGetKey('NOECHO')
CALL SysCls
CALL DrawScreen
CALL DrawMenu
CALL DisplayStats
RETURN


DoSave:
CALL SysCls
CALL SysCurPos  0,0; SAY TxSave01


IF textfile = '' THEN
  DO
    CALL SysCls
    CALL SysCurPos  1,1; SAY TxSave01
    CALL SysCurPos  3,2; SAY TxSave02
    CALL SysCurPos  5,2; SAY '>'
    CALL SysCurPos  5,3; CALL SysCurState 'ON'
    PARSE PULL textfile .
  END
IF textfile = '' THEN CALL DoSave
IF STREAM(textfile, 'c', 'query exists') <> '' THEN
  DO
    CALL SysFileDelete textfile
  END
DO index = 1 TO line.0
  CALL LINEOUT textfile, line.index
END
ok = STREAM(textfile, 'c', 'close')
Modified = 0
CALL SysCls; CALL DrawScreen; CALL DrawMenu; CALL DisplayStats; RETURN


DoQuit:
IF modified <> 0 THEN
  DO
    CALL SysCls
    CALL SysCurPos  0,0; SAY TxQuit01
    CALL SysCurPos  2,2; SAY TxQuit02
    CALL SysCurPos  4,2; SAY TxQuit03
    YesNo = SysGetKey('NOECHO')
    IF (YesNo = 'N') | (YesNo = 'n') THEN
      DO
        CALL SysCls
        EXIT
      END
    ELSE
     DO
       CALL DoSave
     END
  END
CALL SysCls
EXIT


DoRename:
CALL SysCls
CALL SysCurPos  0,0; SAY TxRename01
CALL SysCurPos  2,2; SAY TxRename02
CALL SysCurPos  4,2; SAY TxQuit03
RETURN


DoInfo:
CALL SysCls
CALL SysCurPos  1,1; SAY TxMisc01
totalBytes = 0
maxWidth = 0
DO i = 1 TO line.0
  x = LENGTH(line.i)
  totalBytes = totalBytes + 2 + Length(line.i)
  IF x > maxWidth THEN maxWidth = x
END
CALL SysCls
CALL SysCurPos  0,0; SAY TxInfo01
CALL SysCurPos  2,2; SAY ProgVer
CALL SysCurPos  4,2; SAY TxInfo03
CALL SysCurPos  6,2; SAY TxInfo04
CALL SysCurPos  8,2; SAY textfile
CALL SysCurPos 10,2; SAY TxInfo05 line.0
CALL SysCurPos 11,2; SAY TxInfo06 maxWidth
CALL SysCurPos 12,2; SAY TxInfo07 totalBytes
CALL SysCurPos 13,2; SAY TxInfo08 LoadTime 'seconds'
CALL SysCurPos 23,0; SAY TxMisc02
inkey = SysGetKey('NOECHO')
IF inkey = '00'x | inkey = 'E0'x THEN inkey2 = SysGetKey('NOECHO')
CALL SysCls
CALL DrawScreen
CALL DrawMenu
CALL DisplayStats
RETURN


WriteChar:
IF InsMode                   = 1 THEN
  DO
    line.CursorRowInDocument = INSERT(inkey, line.CursorRowInDocument,,
                                      CursorColumnInDocument - 1, 1)
  END
ELSE
  DO
    line.CursorRowInDocument = OVERLAY(inkey, line.CursorRowInDocument,,
                                       CursorColumnInDocument, 1)
  END
CursorColumnInDocument       = CursorColumnInDocument + 1
CursorColumnInDocumentMem    = CursorColumnInDocument
IF CursorColumnOnScreen      < ScreenRightColumn THEN
  DO
    iline                    = SUBSTR(line.CursorRowInDocument,,
                                      DocumentLeftColumn,,
                                      ScreenWidth, ' ')
    CALL SysCurPos CursorRowOnScreen, ScreenLeftColumn
    SAY iline
    CursorColumnOnScreen     = CursorColumnOnScreen + 1
  END
ELSE
  DO
    DocumentLeftColumn       = DocumentLeftColumn + 1
    CALL Drawscreen
  END
Modified = 1; CALL DisplayStats; RETURN

/* Supporting Subroutines */

LoadTextFile:
CALL SysCls
line. = ''
IF textfile <> '' THEN
  DO
    IF Stream(textfile,'c','query exists') <> '' THEN
      DO
        CALL SysCurState 'OFF'
        Call SysCurPos 1,1; SAY TxMisc01
        i = 0
        LoadTime = TIME('E') /* start timing */
        DO UNTIL LINES(textfile) = 0
          i = i + 1
          line.i = LineIn(textfile)
        END
        LoadTime = TIME('E') /* end timing */
        ok = STREAM(textfile,'c','close')
        line.0 = i
        CALL SysCls
      END

    /* Need to add code in case the file does not exist */

  END
ELSE
  DO
    line.0 = 1
  END
RETURN


DrawScreen:
x         = ScreenTopRow
DO i      = DocumentTopRow TO (DocumentTopRow + ScreenHeight - 1)
  oline.i = SUBSTR(line.i, DocumentLeftColumn, ScreenWidth, ' ')
  CALL SysCurPos x, ScreenLeftColumn; SAY(oline.i)
  x       = x + 1
END
/* Debug */ CALL SysCurPos ScreenBottomRow + 1, ScreenLeftColumn
/* Debug */ SAY '*'
RETURN


DrawMenu:
CALL SysCurPos ScreenBottomRow + 1, ScreenLeftColumn
SAY  COPIES('',ScreenRightColumn + 1 - ScreenLeftColumn)
CALL SysCurPos ScreenBottomRow + 3, ScreenLeftColumn
SAY  TxMain07 FILESPEC("N",textfile)
CALL SysCurPos ScreenBottomRow + 4, ScreenLeftColumn
SAY  TxMain08

RETURN


DisplayStats:
CALL SysCurPos ScreenBottomRow + 2, ScreenLeftColumn
SAY  COPIES(' ',ScreenRightColumn + 1 - ScreenLeftColumn)
CALL SysCurPos ScreenBottomRow + 2, ScreenLeftColumn
IF Modified = 1 THEN X = TxMain06
ELSE      X = ''
IF InsMode = 1 THEN Y = TxMain04
ELSE     Y = TxMain05
SAY  TxMain01 CursorRowInDocument,
     TxMain02 line.0 '',
     TxMain03 CursorColumnInDocument '',
     Y '',
     X
RETURN


DoErrorBeep:
CALL BEEP 800,25
RETURN

/* Data Routines */

LoadKeys:
Enter_Key      = X2C('0D')
Backspace_Key  = X2C('08')
Tab_Key        = X2C('09')
Esc_Key        = X2C('1B')
Ctrl_F         = X2C('06')
Ctrl_G         = X2C('07')
Insert_Key     = X2C('52') /* Extended Key Codes */
Ctrl_Insert    = X2C('92')
Delete_Key     = X2C('53')
Ctrl_Delete    = X2C('93')
Home_Key       = X2C('47')
Ctrl_Home      = X2C('77')
End_Key        = X2C('4F')
Ctrl_End       = X2C('75')
PgUp_Key       = X2C('49')
PgDn_Key       = X2C('51')
DnArrow_Key    = X2C('50')
UpArrow_Key    = X2C('48')
RightArrow_Key = X2C('4D')
LeftArrow_Key  = X2C('4B')
F1             = X2C('3B')
F2             = X2C('3C')
F3             = X2C('3D')
F7             = X2C('41')
F12            = X2C('86')
RETURN


Deutsche:
TxMain01 = 'Zeile'
TxMain02 = 'von'
TxMain03 = 'Spalte'
TxMain04 = ''
TxMain05 = ''
TxMain06 = ''
TxMain07 = 'Datei:'
TxMain08 = 'F1=Hilfe  F2=Sichern  F3=Ende  F4=Info'

TxHelp01 = 'Hilfe'
TxHelp02 = 'Enter .......... Fgt neue Zeile ein'
TxHelp03 = 'Backspace ...... Lscht Buchstaben links vom Cursor'
TxHelp04 = 'Tab ............ Bewegt den Cursor zum nchsten Tabulator'
TxHelp05 = 'Esc ............ Schliet das Dokument'
TxHelp06 = 'Einfg .......... Wechselt zwischen Einfgen und berschreiben'
TxHelp07 = ''
TxHelp08 = ''
TxHelp09 = 'Entf ........... Lscht Buchstaben unter Cursor'
TxHelp10 = ''
TxHelp11 = 'Pos1 ........... Bewegt den Cursor zum Anfang der aktuellen Zeile'
TxHelp12 = 'Strg+Bild auf... Springt an den Beginn des Dokumentes'
TxHelp13 = 'Ende ........... Bewegt den Cursor zum Ende der aktuellen Zeile'
TxHelp14 = 'Strg+Bild ab ... Springt an das Ende des Dokumentes'
TxHelp15 = 'Bild auf ....... Zeigt die vorhergehende Bildschirmseite'
TxHelp16 = 'Bild ab ........ Zeigt die folgende Bildschirmseite'
TxHelp17 = 'Pfeil unten .... Bewegt den Cursor eine Zeile nach unten'
TxHelp18 = 'Pfeil oben ..... Bewegt den Cursor eine Zeile nach oben'
TxHelp19 = 'Pfeil rechts ... Bewegt den Cursor einen Buchstaben nach rechts'
TxHelp20 = 'Pfeil links .... Bewegt den Cursor einen Buchstaben nach links'

TxSave01 = 'Sichern'
TxSave02 = 'Bitte einen Dateinamen angeben:'

TxQuit01 = 'Ende'
TxQuit02 = 'Die editierte Datei wurde verndert'
TxQuit03 = 'Mchten Sie die Datei sichern? ([J]a/[n]ein)'

TxRename01 = ''
TxRename02 = ''

TxInfo01 = 'Info'
TxInfo03 = 'Ein einfacher Texteditor, geschrieben in REXX.'
TxInfo04 = 'Sie bearbeiten gerade diese Datei:'
TxInfo05 = 'Zeilen ....... '
TxInfo06 = 'Breite ....... '
TxInfo07 = 'Bytes ....... '
TxInfo08 = 'Ladezeit ... '

TxMisc01 = 'Bitte warten...'
TxMisc02 = 'Weiter mit beliebiger Taste...'
RETURN


English:
TxMain01 = 'Line:'
TxMain02 = 'of'
TxMain03 = 'Column:'
TxMain04 = 'Insert'
TxMain05 = 'Replace'
TxMain06 = 'Modified'
TxMain07 = 'File:'
TxMain08 = 'F1=Help  F2=Save  F3=Quit  F12=Info'
/* TxMain08 = 'F1=Help  F2=Save  F3=Quit  F7=Rename  F12=Info' */

TxHelp01 = 'Help:'
TxHelp02 = 'Enter ....... Splits the current line at the cursor'
TxHelp03 = 'Backspace ... Deletes character to left of cursor'
TxHelp04 = 'Tab ......... Moves cursor to next tab location'
TxHelp05 = 'Esc ......... Quits EDIT'
TxHelp06 = 'Insert ...... Toggles insert mode'
TxHelp07 = 'Ctrl-Insert . Inserts blank line'
TxHelp08 = 'Delete ...... Deletes character at cursor position'
TxHelp09 = 'Ctrl-Delete . Deletes current line'
TxHelp10 = 'Home ........ Moves cursor to beginning of current line'
TxHelp11 = 'Ctrl-Home ... Shifts view to beginning of document'
TxHelp12 = 'End ......... Moves cursor to end of current line'
TxHelp13 = 'Ctrl-End .... Shifts view to end of document'
TxHelp14 = 'Page Up ..... Shifts view to page above current page'
TxHelp15 = 'Page Down ... Shifts view to page below current page'
TxHelp16 = 'Down Arrow .. Moves cursor one line down'
TxHelp17 = 'Up Arrow .... Moves cursor one line up'
TxHelp18 = 'Right Arrow . Moves cursor one character to right'
TxHelp19 = 'Left Arrow .. Moves cursor one character to left'
TxHelp20 = ''
/* TxHelp20 = 'Ctrl-F/G .... Find/Find Again' */

TxSave01 = 'Save:'
TxSave02 = 'Please type a name for the file:'

TxQuit01 = 'Quit:'
TxQuit02 = 'The file you are editing has been modified.'
TxQuit03 = 'Would you like to save the file? (Y/n)'

TxRename01 = 'Rename:'
TxRename02 = ''
 
TxInfo01 = 'Info:'
TxInfo03 = 'A simple text editor, written in REXX.'
TxInfo04 = 'You are currently editing:'
TxInfo05 = 'Lines ....... '
TxInfo06 = 'Width ....... '
TxInfo07 = 'Bytes ....... '
TxInfo08 = 'Load time ... '

TxMisc01 = 'Please standby...'
TxMisc02 = 'Press any key to continue...'
RETURN
